﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;

[System.Serializable]
//public class GameData
//{
//    public Vector3 BoatPosXYZ;
//    public int IsThereAboat;

//    public GameData(Vector3 pos, int isBoat)
//    {
//        BoatPosXYZ = pos;
//        IsThereAboat = isBoat;
    
//    }
//}

public class FirstController : MonoBehaviour {

    private float RotateSpeed = 2f;
    private float Radius = 0.9f;

    private Vector3 _centre;
    private float _angle;

    public List<Vector4> positionArray = new List<Vector4>();
    public Vector4 playerPositionPlussBoatOrnot;
    private Vector3 Position;

    GameObject obj;
    Collider objCollider;

    Camera cam;
    Plane[] planes;


    private void Start()
    {
        transform.position = new Vector3(4, 0, 4);
       
        cam = Camera.main;
        planes = GeometryUtility.CalculateFrustumPlanes(cam);
        objCollider = GetComponent<Collider>();

        _centre = transform.position;
        InvokeRepeating("ChangePos", 0, 20);
        InvokeRepeating("Rotation", 0, 5);
    }

    void ChangePos()
    {
        _centre += new Vector3((float)1, 0, (float)1);
    }

    void Rotation()
    {
        transform.Rotate(0, 90, 0);
    }

    //public void SaveFile()
    //{
    //    string destination = Application.persistentDataPath + "/save.dat";
    //    FileStream file;

    //    if (File.Exists(destination)) file = File.OpenWrite(destination);
    //    else file = File.Create(destination);

    //    //GameData data = new GameData(currentScore, currentName, currentTimePlayed);
    //    GameData data = new GameData(playerPositionPlussBoatOrnot,1);
    //    BinaryFormatter bf = new BinaryFormatter();
    //    bf.Serialize(file, data);
    //    file.Close();
    //}

    private void Update()
    {
        Position=this.transform.position;
        playerPositionPlussBoatOrnot = Position;
        playerPositionPlussBoatOrnot[3]=1;
        positionArray.Add(playerPositionPlussBoatOrnot);
       
        
        //Debug.Log("X:" + playerPosition.x + " Y:" + playerPosition.y + " Z:" + playerPosition.z);
        //Debug.Log("players position:" + playerPositionPlussBoatOrnot);


        _angle += RotateSpeed * Time.deltaTime;
        var offset = new Vector3(Mathf.Sin(_angle) * Radius, (float)(-0.24), Mathf.Cos(_angle) * Radius);
        transform.position = _centre + offset;


        //if (GeometryUtility.TestPlanesAABB(planes, objCollider.bounds))
        //{
        //    Debug.Log("Barco has been detected!");
        //}
        //else
        //{
        //    Debug.Log("Nothing has been detected");
        //}
    
    }


}

    

